com.fasterxml.jackson.databind.cfg

## Class ContextAttributes

- java.lang.Object
- - com.fasterxml.jackson.databind.cfg.ContextAttributes

Direct Known Subclasses:
  ContextAttributes.Impl

    public abstract class ContextAttributes
    extends Object

Helper class used for storing and accessing per-call attributes. Storage is two-layered: at higher precedence, we have actual per-call (`ObjectMapper.readValue` or `ObjectMapper.writeValue`) attributes; and at lower precedence, default attributes that may be defined for Object readers and writers.

Note that the way mutability is implemented differs between kinds of attributes, to account for thread-safety: per-call attributes are handled assuming that instances are never shared, whereas changes to per-reader/per-writer attributes are made assuming sharing, by creating new copies instead of modifying state. This allows sharing of default values without per-call copying, but requires two-level lookup on access.

To set default attributes, use `withSharedAttributes(Map)` or `withSharedAttribute(Object, Object)`, starting with "empty" instance (see `getEmpty()`). For example:

       ContextAttributes attrs = ContextAttributes.getEmpty()
         .withSharedAttribute("foo", "bar")
         .withSharedAttribute("attr2", "value2");

Since:
  2.3

### Nested Class Summary

Nested Classes
`static class` `ContextAttributes.Impl`

### Constructor Summary

Constructors
Constructor and Description
`ContextAttributes()`

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
`abstract Object` `getAttribute(Object key)` Accessor for value of specified attribute
`static ContextAttributes` `getEmpty()` Accessor for an empty instance of `ContextAttributes`: usable as-is, or as a starting point for building up a set of default attributes.
`abstract ContextAttributes` `withoutSharedAttribute(Object key)`
`abstract ContextAttributes` `withPerCallAttribute(Object key, Object value)` Mutator used during call (via context) to set value of "non-shared" part of attribute set.
`abstract ContextAttributes` `withSharedAttribute(Object key, Object value)` Fluent factory method for creating a new instance with an additional shared attribute.
`abstract ContextAttributes` `withSharedAttributes(Map<?,?> attributes)` Fluent factory method for creating a new instance with specified set of shared attributes.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ContextAttributes

    public ContextAttributes()

### Method Detail

#### getEmpty

    public static ContextAttributes getEmpty()

Accessor for an empty instance of `ContextAttributes`: usable as-is, or as a starting point for building up a set of default attributes.

#### withSharedAttribute

    public abstract ContextAttributes withSharedAttribute(Object key,
                                                          Object value)

Fluent factory method for creating a new instance with an additional shared attribute.

Parameters:
  `key` - Name of the attribute to add
  `value` - Value of the attribute to add; may be null, in which case attribute will be removed if it already exists.
Returns:
  New instance of `ContextAttributes` that has specified change.

#### withSharedAttributes

    public abstract ContextAttributes withSharedAttributes(Map<?,?> attributes)

Fluent factory method for creating a new instance with specified set of shared attributes. Any shared attributes that already exist will be replaced

Parameters:
  `attributes` - Map of shared attributes to add, replacing any existing ones.
Returns:
  New instance of `ContextAttributes` that has specified shared attributes.

#### withoutSharedAttribute

    public abstract ContextAttributes withoutSharedAttribute(Object key)

#### getAttribute

    public abstract Object getAttribute(Object key)

Accessor for value of specified attribute

#### withPerCallAttribute

    public abstract ContextAttributes withPerCallAttribute(Object key,
                                                           Object value)

Mutator used during call (via context) to set value of "non-shared" part of attribute set.